#! /bin/sh

TESTID=ahelp-smoke001
export TESTID

#
# Replace with variable via configure
#
ASCDS_QUIET=1; export ASCDS_QUIET
ASCDS_OVERRIDE=1; export ASCDS_OVERRIDE
. setup.sh

#
# Setup test env
#
TESTDIR=$ASCDS_INSTALL/test/smoke/data; export TESTDIR
if [ "$ASCDS_SMOKE_DIR" = "" ]; then
   OUTDIR=$ASCDS_WORK_PATH/smoke.${LOGNAME}/$TESTID; export OUTDIR
else
   OUTDIR=$ASCDS_SMOKE_DIR/smoke.${LOGNAME}/$TESTID; export OUTDIR
fi
SAVEDIR=$TESTDIR/; export SAVEDIR

INDIR=$TESTDIR

OUTFILE=${OUTDIR}/${TESTID}.txt

if test -d $OUTDIR
then
   \rm -rf $OUTDIR
fi
mkdir -p $OUTDIR

#
# Run command
#
printf "Running test $TESTID "
echo " AHELP SMOKE TEST LOG " > $OUTFILE
echo "" > $OUTFILE

#check that ahelp can parse xml
printf "."
echo "  -- TEST AHELP FROM A FILE" >> $OUTFILE
ahelp -n 80 -f $INDIR/ahelpsmoketest.xml >> $OUTFILE 2>&1

#
# Run checks on the output files.
#
state=0
printf "."
diff "$OUTFILE" "$SAVEDIR/${TESTID}.txt" >> $OUTDIR/diff.log 2>&1
if test $? != 0
then
   state=1
fi
printf ". "

#
# Exit condition
#
if test $state = 0
then
  echo "PASS"

  if echo "$OUTDIR" | grep "$TESTID" >/dev/null
  then
     rm $OUTDIR/${TESTID}.*
     rm $OUTDIR/diff.log
     rmdir $OUTDIR
  fi
else
  echo "FAIL"
fi

exit $state
