#! /bin/bash

usage()
{
    \echo "Usage: ${1} <Root of CIAO> | set \$ASCDS_INSTALL"
    exit
}

pcfix()
{
    PC_FILES="`ls *.pc`"
    for FILEPC in ${PC_FILES} ; do
	\rm -f ${FILEPC}.new
	\echo "prefix=${root}/ots" > ${FILEPC}.new
	\grep -v "^prefix=" ${FILEPC} >> ${FILEPC}.new
	\rm -f ${FILEPC}
	\mv ${FILEPC}.new ${FILEPC}
    done
}

# If the user passes the ciao root directory use that
# else check to see if ASCDS_INSTALL is set.

if [ "x${1}" == "x" ] ; then
    if [ "x${ASCDS_INSTALL}" == "x" ] ; then
	usage ${0}
    else
	root="${ASCDS_INSTALL}"
    fi
else
    root="${1}"
fi

export root
if [ -d ${root}/lib/pkgconfig ] ; then
    \cd ${root}/lib/pkgconfig
    pcfix
fi
if [ -d ${root}/ots/lib/pkgconfig ] ; then
    \cd ${root}/ots/lib/pkgconfig
    pcfix
else
   \echo "Error cannot find package config directory ${root}/ots/lib/pkgconfig"
   usage ${0}
fi
