#! /bin/bash
# script to change the build locations of Readline
# to the install locations so people who link against
# CIAO won't have to add -lreadline and -lhistory
# to their link lines.

fix_lib()
{
    \chmod u+w ${1}
    Old_lib=`\otool -L ${1} | grep ${2} | \cut -f 1 -d " "`
    if [ "${Old_lib}" != "" ] ; then
       New_lib="${3}/`basename $Old_lib`"
       \install_name_tool -change ${Old_lib} ${New_lib} ${1}
    fi
    \chmod u-w ${1}
}

fixrl()
{
    Dir="`pwd`"
    if [ -f "lib/${1}" ] ; then
	fix_lib lib/${1} libreadline ${Dir}/ots/lib
	fix_lib lib/${1} libhistory ${Dir}/ots/lib
    else
	echo "Missing lib/${1}"
    fi
}

if [ -f "/usr/bin/install_name_tool" ] ; then
    if [ -f "/usr/bin/otool" ] ; then
	fixrl libpix.dylib
	fixrl libcaldb4.dylib
# libcxcparam.dylib no longer seems to have readline in it.
# I am leaving it in the script for now in case it is used
# with CIAO 4.0
	fixrl libcxcparam.dylib
	fixrl libds.dylib
	fixrl libNewHdr2.dylib
    fi
fi
