#! /bin/sh

TESTID=pycrates-smoke001; export TESTID

INFILE=''
OUTFILE=''
OUTLIST="${OUTFILE}"
TOLFILE="crates-smoke.tol"
THISDIR=`dirname $0`; export THISDIR
#
# Synopsis: Crates Self Test
TESTCMD="$THISDIR/pycrates-smoketest.py all"

# Setup CIAO environment
#   (replace with variable via configure)
#
ASCDS_QUIET=1; export ASCDS_QUIET
#ASCDS_OVERRIDE=1; export ASCDS_OVERRIDE
. setup.sh
if test -f ${ASCDS_INSTALL}/bin/ciao_setup.sh
then
    . ${ASCDS_INSTALL}/bin/ciao_setup.sh
fi

#
# Setup test env  
#
TESTDIR=$ASCDS_INSTALL/test/smoke/data; export TESTDIR
OUTDIR=$ASCDS_WORK_PATH/smoke.${LOGNAME}/$TESTID; export OUTDIR
SAVEDIR=$TESTDIR; export SAVEDIR

INDIR=$TESTDIR

#
# --!!  check $ASCDS_WORK_PATH exist, writeable, has enough space
#
# Setup local parameter location
PFILES="$OUTDIR/param;$ASCDS_INSTALL/param"; export PFILES

if test -d $OUTDIR
then
  rm -rf $OUTDIR
fi

mkdir -p $OUTDIR/param

#
# Run command
#
printf "Running test $TESTID"
printf " ." 
(eval "$TESTCMD")  #> /dev/null 2>&1
if test $? != 0
then
  echo ".. FAIL"
  exit 1
fi

#
# Check results.
#
state=1
if test -f $OUTDIR/grade.txt
then
  result=`\cat $OUTDIR/grade.txt`
  if test $result = "PASS"
  then
    state=0
  else
    state=1
  fi
else
  state=1
fi
printf "." 

#
# Exit condition
#
printf ". " 
if test $state = 0
then
  echo "PASS"
  rm -rf $OUTDIR
  xx=`\ls $ASCDS_WORK_PATH/smoke.${LOGNAME}`
  if test "x$xx" = "x"
  then
    rmdir $ASCDS_WORK_PATH/smoke.${LOGNAME}
  fi
else
  echo "FAIL"
fi

exit $state
