/*                                                                
**  Copyright (C) 2003-2004,2006-2009  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

/*****************************************************************/
/*                                                               */
/*   afkernel .h                                                 */
/*                                                               */
/*   Definitions and function prototypes for ASCII file type     */
/*                                                               */
/*                                                               */
/*                                                               */
/*****************************************************************/

#include "dmilib.h"
#include "dmlib.h"
#include "dmkernel.h"

void       afInit( void );
void       afKeyDelete( dmDescriptor* dd );
dmErrCode  afBlockFlush( dmBlock* block );
void       afBlockUpdateFilter( dmBlock* block, dmSubspace* rts );
void       afImageSetAxes( dmBlock* block, const dmDataType type, const long* axlen, const long naxes );
void       afColCreate( dmBlock* block, dmDescriptor* dd, void* kdd, char* hint );
dmErrCode  afColRead( dmDescriptor* dd, long* llpix, long* urpix, long* dpix, long row1, long row2, void* data );
dmErrCode  afColWrite( dmDescriptor* vector, long* llpix, long* urpix, long* dpix, long row1, long row2, void* data );
dmErrCode  afReadRows( dmBlock* block, dmBuffer* buf, long row1, long row2 );
dmErrCode  afWriteRows( dmBlock* block, dmBuffer* buf, long row1, long row2 );
dmBool     afDatasetAccess( const char* filename, const char* mode );
void       afDescriptorFree( dmDescriptor* dd );
dmDataset* afDatasetOpen(const char* filename, const char* hint, const char* mode );
dmErrCode  afSetHint( dmBlock* block, const char* name, const char* value );
void       afDatasetPrint( const dmDataset* ds );
void       afDatasetClose( dmDataset* ds );
void       afDatasetDelete( dmDataset* ds );

dmDataset*  afDatasetCreate( const char* filename, const char* hint );
dmBlock* afBlockOpen( dmDataset* ds, long BlockNo, dmBlockType type, char* hint );
dmBlock*   afBlockCreate( dmDataset* ds, long no, const char* name, dmBlockType type, void* kb, char* hint );
dmErrCode afBlockClose( dmBlock* block );
dmErrCode afBlockDelete( dmDataset* ds, const long blockNo );
void afGetKernelKey( dmBlock* block, long no, char* buf, long maxlen );
long afGetNoKernelKeys( dmBlock* block );
dmBool      afWriteComment( dmBlock* block, const long keyno, const char* tag, const char* comment );
dmBool      afReadComment( dmBlock* block, const long keyno, char** tag, char** comment );
dmDescriptor*    afKeyWrite( dmBlock* block, const long keyno, const char* name, const dmDataType type, const void* value, long nvals,              const char* unit, const char* comment );
dmErrCode afColSetRange( dmDescriptor* ddp );
dmErrCode afColSetNull( dmDescriptor* dd );
dmErrCode afColSetBin( dmDescriptor* dd );
void afSubspaceDescriptorWrite( dmDescriptor* dd, long cptno, char* value, char* tabname );
void afSubspaceTableWrite( dmDescriptor* dd, char* tabname, void* val1, void* val2, long nvals );
void afCoordWrite( dmDescriptor* dd );
void afBlockSetPref( dmBlock* block, char** prefcols, const long npref );
long afBufferSize( dmBlock* block );
void afColFlush( dmDescriptor* dd );
dmErrCode afBlockReadRows( dmBlock* block, void* data );
dmErrCode afBlockWriteRows( dmBlock* block, void* data );
