/*                                                                
**  Copyright (C) 2003-2004,2006-2009  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

/*****************************************************************/
/*                                                               */
/*   ryi.h                                                       */
/*                                                               */
/*   Definitions and function prototypes for ASCII file type     */
/*                                                               */
/*                                                               */
/*                                                               */
/*****************************************************************/
#include "dmi.h"

/*
 * Allocate a column descriptor.
 */
dmDescriptor* ryi_column_alloc( dmBlock* block, long no, 
				const char* name, 
				dmDataType type, long width,
				const char* unit, const char* desc, 
				long dim, dmDescriptor** cpts, 
				long naxes, const long* axes, 
				double val, double pix, double delt, 
				void* kdd );

/* 
 * Allocate a coordinate descriptor 
 */
dmDescriptor* ryi_coord_alloc( dmBlock* block,  dmDescriptor *col_dd,
                               long no, 
			       const char* name, 
			       const char* transform,
			       double *val, double *pix, double *delt, 
			       long dim,
			       void* kdd );
