/*                                                                
**  Copyright (C) 2004-2005,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "ascdm.h"
#include <stdlib.h>
#include <stdio.h>

/*  gcc -g fitssub3test.c -I$ASCDS_INSTALL/include -L$ASCDS_INSTALL/lib -lascdm -o fitssub3test -lregion -L$ASCDS_INSTALL/ots/lib -lcfitsio */


int main( int argc, char* argv[] )
{
  long ii;

  //  char *infile = "/data/regression_test/development/indata/datamodel/indt043m001.fits";
  
  char *infile = NULL;
  dmBlock *blk = NULL;
  dmDescriptor *img = NULL;

  long *data = NULL;
  long *lAxes = NULL;

  long low_left[3] = {2, 3, 1 };
  long up_right[3] = {4, 5, 2 };

  long ntotal = ((up_right[0]-low_left[0]+1)*
		 (up_right[1]-low_left[1]+1)*(up_right[2]-low_left[2]+1));

  infile = argv[1];
  blk = dmImageOpen( infile );
  img = dmImageGetDataDescriptor( blk );

  if (! blk || !img )
    exit(1);

  data = (long*)calloc( ntotal, sizeof(long));
  dmGetArrayDimensions( img, &lAxes );

  printf("%ld\t%ld\t%ld\t%ld\n", ntotal, lAxes[0], lAxes[1], lAxes[2]);
  
  dmImageDataGetSubArray_l( img, low_left, up_right, data );


  for ( ii = 0; ii < ntotal; ii++)
  {
    printf("%ld\t",data[ii]);
  }
  printf("\n");

  dmImageClose(blk);
  free(data);
  exit(0);
}

