#include <ascdm.h>
#include <stdlib.h>
#include <stdio.h>


/*
  gcc -g fitssub4test.c -I$ASCDS_INSTALL/include -L$ASCDS_INSTALL/lib -lascdm -o fitssub4test -lregion -L$ASCDS_INSTALL/ots/lib -lcfitsio */

int main( int argc, char* argv[] )
{
  long ii;

  //  char *infile = "/data/regression_test/development/indata/datamodel/indt043m002.fits[(#3,#4)=circle(20,20,5)][opt full]";
  
  char *infile = NULL;

  dmBlock *blk = NULL;
  dmDescriptor *img = NULL;

  float *data = NULL;
  long *lAxes = NULL;

  //  long low_left[4] = {1, 1, 1, 1 };
  //  long up_right[4] = {5, 6, 2, 2 };

  long low_left[4] = {5, 1, 17, 17};
  long up_right[4] = {6, 2, 18, 17};

  long ntotal = ((up_right[0]-low_left[0]+1)*
		 (up_right[1]-low_left[1]+1)*(up_right[2]-low_left[2]+1)*
  (up_right[3]-low_left[3]+1) );


  infile = argv[1];
  blk = dmImageOpen( infile );
  img =  dmImageGetDataDescriptor( blk );

  if ( !blk || !img )
    exit(1);

  data = (float*)calloc( ntotal, sizeof(float));
  dmGetArrayDimensions( img, &lAxes );

  printf("%ld\t%ld\t%ld\t%ld\t%ld\n", ntotal, lAxes[0], lAxes[1], lAxes[2], lAxes[3]);
  
  dmImageDataGetSubArray_f( img, low_left, up_right, data );


  for ( ii = 0; ii < ntotal; ii++)
  {
    printf("%11.9e\t",data[ii]);
  }
  printf("\n");

  dmImageClose(blk);
  free(data);
  exit(0);

}
