/*                                                                
**  Copyright (C) 2004-2005,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */


#include "ascdm.h"
#include <stdio.h>

// This program outputs to stdout a string containing the names of all
// installed datamodel kernels

int main( int argc, char* argv[] )
{
  dmErrCode    status = 0;

  char         sKernelList[50];         // contains string list of names
  char        *psName         = NULL;   // pointer to name in list
  char       **ppsKernelNames = NULL;   // list of pointers to names
  long         lKernelCount   = 0;      // number of kernels installed
  int          ii             = 0;      // loop counter

  sKernelList[0] = '\0';

  // Get the number of installed kernels and a list of names

  status = dmKernelGetList(&ppsKernelNames, &lKernelCount );

  // Form an output string of names from the names pointer list

  for ( ii = 0; ii < lKernelCount; ii++)
  {
    psName = ppsKernelNames[ii];

    strcat( sKernelList, psName );
    strcat( sKernelList, " ");

    // function dmKernelGetList() allocates space, so free it
    free (psName);
  }
 
  // function dmKernelGetList() allocates space, so free it
  free ( ppsKernelNames);

  // send the output string to the regression test via stdout

  printf( "%s", sKernelList );


  return 0;
}
