/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

/*****************************************************************/
/*                                                               */
/*   dmuarray.c                                                  */
/*                                                               */
/*                                                               */
/*                                                               */
/*                                                               */
/*****************************************************************/

#include "dmulib.h"
#include "dmnutils.h"


/***************************************************************/
/*                                                             */
/* Function:   dmu_pixelno_from_pixel                          */
/*                                                             */
/* Description:                                                */
/*     Given the pixel coordinates, where in the array are we? */
/*                                                             */
/*  Input parameters:                                          */
/*            long    *Pixel - coordinates                     */
/*            long    *axes  - axes array                      */
/*            long     naxes - number of axes                  */
/*                                                             */
/*  Output parameters:                                         */
/*            none                                             */
/*                                                             */
/*  Returns:                                                   */
/*            long  PixelNo - pixel number                     */
/*                                                             */
/***************************************************************/
long dmu_pixelno_from_pixel( long* Pixel, long* axes, long naxes )
{
  long PixelNo = 0;

  PixelNo = pixelno_from_pixel( Pixel, axes, naxes );

  return PixelNo;
}


/***************************************************************/
/*                                                             */
/* Function:   dmu_pixelfrom_pixelnol                          */
/*                                                             */
/* Description:                                                */
/*     What are the coordinates of the n'th pixel in the image?*/
/*                                                             */
/*  Input parameters:                                          */
/*            long     PixelNo - pixel number                  */
/*            long    *axes    - axes array                    */
/*            long     naxes   - number of axes                */
/*                                                             */
/*  Output parameters:                                         */
/*            long    *Pixel - pixel coordinates               */
/*                                                             */
/*  Returns:                                                   */
/*            void                                             */
/*                                                             */
/***************************************************************/
void dmu_pixel_from_pixelno( long PixelNo, long* axes, long naxes, long* Pixel)
{
  pixel_from_pixelno( PixelNo, axes, naxes, Pixel );
}


