/*                                                                
**  Copyright (C) 1997-1998,2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

/*-------------------------------------------------------------------------

   FILE NAME: 		%W% %E% %U%

   DEVELOPMENT: 	AXAF Science Center DataModel
 			mnoble@cfa.harvard.edu (Initial version)

   DESCRIPTION:		Header file common to several example programs.

---------------------------------------------------------------------------
---------------------------------------------------------------------------*/

#ifndef _DMEXAMPLES_H
#define _DMEXAMPLES_H

#include <ctype.h>

#ifdef _cplusplus
extern "C" {
#endif

extern int   ListInfo(dmBlock *blk, long blNo, long dumpKeys, long dumpCoords);
extern int   ListBlocks(dmDataset *ds,long dumpKeys,long dumpCoords);
extern int   PrintTransform(dmDescriptor *dd);
extern void ut_error_status( void );
/*-------------------------------------------------------------------------*/
/*				macros and #defines			   */
/*-------------------------------------------------------------------------*/

#define ERROR(str)	{  fprintf(stderr,"\nFATAL ERROR: %s\n",str);        \
			   ut_error_status();   \
  			   return dmFAILURE;				     \
			}

#define DATASET		"x9xtst.ds"
#define FULLDATASET	"dmtest.fits"		/* fully populated FITS file */
#define EMPTYDATASET	"empty.fits"		/* existing, empty FITS file */
#define NEWEMPTYDATASET	"new.fits"		/* new, empty FITS file      */
#define	LMAX		256
#define COL1		"IonicCol"
#define COL2		"GothicCol"
#define COL3		"DailyCol"
#define COL4		"AnotherB"
#define COL5		"AnotherA"
#define COL6		"strngCOL"
#define COL7		"LOGICCOL"
#define COL8		"TheEigth"
#define COL9		"TheNinth"
#define COL10		"TheTenth"
#define COL11		"TheEleventh"
#define COL12		"Col12"
#define COL13		"Col13"

#define SHORTKEY	"SHORTKEY"
#define SHORTVAL	999
#define TEXTKEY		"TEXTKEY"
#define TEXTVAL		"CEEBEEGEEBEE"
#define DOUBLEKEY	"DOUBLEKY"
#define DOUBLEVAL	737.373
#define LOGICALKEY	"LOGICALK"
#define	LOGVAL		1
#define STRCOLSIZE	80
#define COMMENTSIZE     20

#define COMMENT1 "ASC DM TEST COMMENT 1"
#define COMMENT2 "ASC DM TEST COMMENT 2"
#define COMMENT3 "ASC DM TEST COMMENT 3"
#define COMMENT4 "ASC DM TEST COMMENT 4"
#define HISTORY1 "ASC DM TEST HISTORY 1"
#define HISTORY2 "ASC DM TEST HISTORY 2"
#define HISTORY3 "ASC DM TEST HISTORY 3"

/*-------------------------------------------------------------------------*/

#ifdef _cplusplus
}
#endif

#endif
