/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

/*****************************************************************/
/*                                                               */
/*   dmlib.h                                                     */
/*                                                               */
/*   This file contains global defines.                          */
/*                                                               */
/*                                                               */
/*                                                               */
/*****************************************************************/

#ifndef DMLIB_H
#define DMLIB_H


#ifndef DM_DEFINE_GLOBALS
#define DMGLOBAL extern
#else
#define DMGLOBAL
#endif

#include "dmerror.h"

#define dmError   Error
#define dmTextBuf TextBuf

DMGLOBAL dmError*  dm_error;
DMGLOBAL dmTextBuf dm_errbuf;
DMGLOBAL long      dm_errmask;
DMGLOBAL int       dmverbose;
DMGLOBAL long      dm_global;
DMGLOBAL long      dm_buffersize;

#define dmBUFFER_ROWS_DEFAULT 1024

/* Global flags for dm_global */

/* Use TSTART/TSTOP keys for TIME range, not just subspace */
#define DM_GLOBAL_TSTART_RANGE  0x01
/* Make everything just like CIAO2.2 DM behaviour, even if silly */
#define DM_GLOBAL_OLD           0x02
#endif
