from cxcdm import *
from cxcdm._cxcdm import _dmSetVerbose
import sys


# -------------------------------------------------------------------------
# User closes DM objects.. 
# -------------------------------------------------------------------------
def testTableMemory (infile, outfile=sys.stdout):
   _dmSetVerbose( 2 )

   print >> outfile, "dmTableOpen({0})            # open block".format (infile);
   b = dmTableOpen( infile )

   print >> outfile, "dmBlockGetDataset( b )         # grab dataset from block"
   ds  = dmBlockGetDataset( b )

   print >> outfile, "dmDatasetGetBlock( ds, 2 )     # new object to same block"
   tab = dmDatasetGetBlock( ds, 2 )

   print >> outfile, "dmTableClose( b )              # manually close block and ds"
   print >> outfile, "                               #  - ds and tab should become empty"
   dmTableClose( b )

   print >> outfile, "Check 'b'   is empty = ", dmIsEmpty( b )
   print >> outfile, "Check 'tab' is empty = ", dmIsEmpty( tab )
   print >> outfile, "Check 'ds'  is empty = ", dmIsEmpty( ds )

   print >> outfile, "Delete b"
   del b

   print >> outfile, "Delete tab"
   del tab

   print >> outfile, "Delete ds"
   del ds


   print >> outfile, "# -------------------------------------------------------------------------"
   # Does not close DM objects.. lets the python dealloc functions take care of it.
   print >> outfile, "# -------------------------------------------------------------------------"


   print >> outfile, "dmTableOpen({0})            # open block".format(infile)
   b = dmTableOpen( infile )

   print >> outfile, "dmBlockGetDataset( b )         # grab dataset from block"
   ds  = dmBlockGetDataset( b )

   print >> outfile, "dmDatasetGetBlock( ds, 2 )     # new object to same block"
   tab = dmDatasetGetBlock( ds, 2 )

   print >> outfile, "Check 'b'   is empty = ", dmIsEmpty( b )
   print >> outfile, "Check 'tab' is empty = ", dmIsEmpty( tab )
   print >> outfile, "Check 'ds'  is empty = ", dmIsEmpty( ds )

   print >> outfile, "Delete b"
   del b

   print >> outfile, "Delete tab"
   del tab

   print >> outfile, "Delete ds"
   del ds

   print >> outfile, "# -------------------------------------------------------------------------"
   print >> outfile, "# -------------------------------------------------------------------------"

   print >> outfile, "dmBlockOpen({0})            # open block".format (infile)
   b = dmBlockOpen( infile )

   print >> outfile, "dmBlockGetDataset( b )         # grab dataset from block"
   ds  = dmBlockGetDataset( b )

   print >> outfile, "dmDatasetMoveToBlock( ds, 2 )  # new object to same block (new C ptr)"
   tab = dmDatasetMoveToBlock( ds, 2 )

   print >> outfile, "dmBlockClose( b )              # manually close 1 block, ds remains open"
   dmBlockClose( b )

   print >> outfile, "del ds                         # drop python link to dataset.. ds remains open"
   del ds

   print >> outfile, "dmBlockClose( tab )            # manually close other block, ds remains open"
   dmBlockClose( tab )

   print >> outfile, "Check 'b'   is empty = ", dmIsEmpty( b )
   print >> outfile, "Check 'tab' is empty = ", dmIsEmpty( tab )

   del b
   del tab

   print >> outfile, "# -------------------------------------------------------------------------"
   # Lets get some descriptors in here!
   print >> outfile, "# -------------------------------------------------------------------------"


   print >> outfile, "dmBlockOpen({0})            # open block".format (infile)
   b = dmBlockOpen( infile )

   print >> outfile, "c = dmTableOpenColumn(b, 'FCOL')      # open a column "
   c = dmTableOpenColumn(b, "FCOL")

   print >> outfile, "v = dmGetData( c )                    # pull out a value "
   v = dmGetData( c )

   print >> outfile, "del b                                 # simulate leaving a subroutine.. return v"
   del b
   print >> outfile, "del c                                 # simulate leaving a subroutine.. return v"
   del c


   # Try deleting the descriptors first
   print >> outfile, "# -------------------------------------------------------------------------"

   print >> outfile, "dmBlockOpen({0})            # open block".format (infile)
   b = dmBlockOpen( infile )

   print >> outfile, "c = dmTableOpenColumn(b, 'FCOL')      # open a column "
   c = dmTableOpenColumn(b, "FCOL")

   print >> outfile, "dmDescriptorDelete( c )               # delete the descriptor without deleting the variable "
   try:
      dmDescriptorDelete( c )
   except:
      del c 
   else:
      print >> outfile, "v = dmGetData( c )                   # try to access data from the descriptor"
      v = dmGetData (c)

   print >> outfile, "del b                                 # now delete the block"
   del b


   _dmSetVerbose( 0 )

def testImageMemory (infile, outfile=sys.stdout):
   _dmSetVerbose( 2 )

   print >> outfile, "dmImageOpen({0})            # open block".format (infile)
   b = dmImageOpen( infile )

   print >> outfile, "dmImageClose( b )              # manually close block"
   print >> outfile, "                               # block and internal ds should be cleared "
   dmImageClose( b )

   print >> outfile, "Check 'b'   is empty = ", dmIsEmpty( b )

   print >> outfile, "Delete b"
   del b

   print >> outfile, "# -------------------------------------------------------------------------"
   # Does not close DM objects.. lets the python dealloc functions take care of it.
   print >> outfile, "# -------------------------------------------------------------------------"


   print >> outfile, "dmImageOpen({0})            # open block".format (infile)
   b = dmImageOpen( infile )

   print >> outfile, "dmBlockGetDataset( b )         # grab dataset from block"
   ds  = dmBlockGetDataset( b )

   print >> outfile, "dmDatasetGetBlock( ds, 2 )     # new object to same block"
   image = dmDatasetGetBlock( ds, 2 )

   print >> outfile, "Check 'b'   is empty = ", dmIsEmpty( b )
   print >> outfile, "Check 'image' is empty = ", dmIsEmpty( image )
   print >> outfile, "Check 'ds'  is empty = ", dmIsEmpty( ds )

   print >> outfile, "Delete b"
   del b

   print >> outfile, "Check 'ds'  is empty = ", dmIsEmpty( ds )

   print >> outfile,"Access the ds"
   dmDatasetGetName (ds)

   print >> outfile, "dmImageClose (image)"
   dmImageClose (image)

   print >> outfile, "Delete ds"
   del ds

   print >> outfile, "# -------------------------------------------------------------------------"
   print >> outfile, "# -------------------------------------------------------------------------"

   print >> outfile, "dmBlockOpen({0})            # open block".format (infile)
   b = dmBlockOpen( infile )

   print >> outfile, "dmBlockGetDataset( b )         # grab dataset from block"
   ds  = dmBlockGetDataset( b )

   print >> outfile, "dmDatasetMoveToBlock( ds, 2 )  # new object to same block (new C ptr)"
   image = dmDatasetMoveToBlock( ds, 2 )

   print >> outfile, "delete  b                      # delete 1 block, ds remains open"
   del b

   print >> outfile, "Check 'ds'  is empty = ", dmIsEmpty( ds )

   print >> outfile, "del ds                         # drop python link to dataset.. ds remains open"
   del ds

   print >> outfile, "dmBlockClose( tab )            # manually close other block, ds remains open"
   dmBlockClose( image )

   print >> outfile, "Check 'image' is empty = ", dmIsEmpty( image )

   del image 

   print >> outfile, "# -------------------------------------------------------------------------"
   # Lets get some descriptors in here! And a sub routine
   print >> outfile, "# -------------------------------------------------------------------------"


   def test ():
      print >> outfile, "dmBlockOpen({0})            # open block".format(infile)
      b = dmImageOpen( infile )

      print >> outfile, "dd = dmImageGetDataDescriptor(b)      # open an image "
      dd = dmImageGetDataDescriptor(b)

      print >> outfile, "v = dmGetData( c )                    # pull out a value "
      v = dmGetData( dd )

      print >> outfile, "v[:5]                                # extract 5 values"
      print >> outfile,v[:5]
      

      return v

   data = test ()
   print >> outfile, "data[:5]                                # extract 5 values"

   print >> outfile,data[:5]

# ----------------------------------------------------------------------
# Test refrence counts for true, false and none returns
# ----------------------------------------------------------------------
def testRefenceCounts (infile, outfile=sys.stdout):
   _dmSetVerbose( 0 )
   print >> outfile, "dmBlockOpen({0})            # open block".format (infile)
   b = dmBlockOpen( infile )
  
   print >> outfile, "btype = dmBlockGetType( b )  # get block type"
   btype = dmBlockGetType( b )

   print >> outfile, "sys.getrefcount (btype == dmIMAGE) == sys.getrefcount (btype == dmIMAGE)  # check refcount for false"
   print >> outfile, sys.getrefcount (btype == dmIMAGE) == sys.getrefcount (btype == dmIMAGE)

   print >> outfile, "sys.getrefcount (btype == dmTABLE) == sys.getrefcount (btype == dmTABLE)  # check refcount for true"
   print >> outfile, sys.getrefcount (btype == dmTABLE) == sys.getrefcount (btype == dmTABLE)

   print >> outfile, "dd = dmTableOpenColumn(b, 'FCOL')  # open descriptor"
   dd = dmTableOpenColumn(b, "FCOL")

   print >> outfile, "sys.getrefcount (dmDescriptorGetType (dd) == dmKEY) == sys.getrefcount (dmDescriptorGetType (dd) == dmKEY)   #check refcount for false"
   print >> outfile, sys.getrefcount (dmDescriptorGetType (dd) == dmKEY) == sys.getrefcount (dmDescriptorGetType (dd) == dmKEY)

   print >> outfile, "sys.getrefcount (dmDescriptorGetType (dd) == dmCOLUMN) == sys.getrefcount (dmDescriptorGetType (dd) == dmCOLUMN)   #check refcount for false"
   print >> outfile, sys.getrefcount (dmDescriptorGetType (dd) == dmCOLUMN) == sys.getrefcount (dmDescriptorGetType (dd) == dmCOLUMN)

   print >> outfile, "sys.getrefcount (dmIsEmpty(dd)) == sys.getrefcount (dmIsEmpty(dd))   #check refcount for false"
   print >> outfile, sys.getrefcount (dmIsEmpty(dd)) == sys.getrefcount (dmIsEmpty(dd))

   print >> outfile, "dmBlockClose (b)  # close block"
   dmBlockClose (b)
   print >> outfile, "sys.getrefcount (dmIsEmpty(dd)) == sys.getrefcount (dmIsEmpty(dd))   #check refcount for true"
   print >> outfile, sys.getrefcount (dmIsEmpty(dd)) == sys.getrefcount (dmIsEmpty(dd))

   print >> outfile, "dmBlockOpen({0})            # open block".format (infile)
   b = dmBlockOpen( infile )

   print >> outfile, "ds = dmBlockGetDataset (b)  # open dataset"
   ds = dmBlockGetDataset (b)

   print >> outfile, "dmDatasetClose (ds)         # close dataset"
   dmDatasetClose (ds)

   print >> outfile, "sys.getrefcount (dmIsEmpty(dd)) == sys.getrefcount (dmIsEmpty(dd))   #check refcount for true"
   print >> outfile, sys.getrefcount (dmIsEmpty(dd)) == sys.getrefcount (dmIsEmpty(dd))



if __name__ == "__main__":

   testTableMemory (sys.argv[1])
   testImageMemory (sys.argv[2])
   testRefenceCounts (sys.argv[1])


