/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include <ctype.h>
#include "utlib.h"

logical cs_digit_char( const char c )
{
 return( isdigit( c ) );
}

logical cs_alpha_char( const char c )
{
 return( isalpha( c ) );
}


logical cs_numeric_char( const char c )
{
 return( isdigit( c ) || c == '+' || c == '-' || c == '.' );
}

logical cs_nancode( const char* buf )
{
 return( 
 cs_eq( buf, "-" ) ||
 cs_eq( buf, "NA" ) ||
 cs_eq( buf, "NAN" ) || cs_eq( buf, "NaN" )
 );
}

