/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "utlib.h"

logical utm_clip_r( const float x, const float y, const float x1, const float x2, const float yy1, const float yy2 )
{
 return(  x >= x1 && x <= x2 && y >= yy1 && y <= yy2 );
}
logical utm_clip_d( const double x, const double y, const double x1, const double x2, const double yy1, const double yy2 )
{
 return(  x >= x1 && x <= x2 && y >= yy1 && y <= yy2 );
}

double utm_rlap_check_d( const double x, const double yy1, const double yy2, logical* left, logical* right )
{
 double u;
 *left = x < yy1;
 *right = x > yy2;
 u = *left  ? yy1 : ( *right ? yy2 : x );
 return( u );
}
float utm_rlap_check_r( const float x, const float yy1, const float yy2, logical* left, logical* right )
{
 float u;
 *left = x < yy1;
 *right = x > yy2;
 u = *left  ? yy1 : ( *right ? yy2 : x );
 return( u );
}

logical utm_overlap_r( const float x1, const float x2, const float yy1, const float yy2,
    float* u1, float* u2 )
{
 logical left1, left2, right1, right2;

 *u1 = rlap_check_r( x1, yy1, yy2, &left1, &right1 );
 *u2 = rlap_check_r( x2, yy1, yy2, &left2, &right2 );
 return( !( right1 || left2 ) );
}

logical utm_overlap_d( const double x1, const double x2, const double yy1, const double yy2,
    double* u1, double* u2 )
{
 logical left1, left2, right1, right2;

 *u1 = rlap_check_d( x1, yy1, yy2, &left1, &right1 );
 *u2 = rlap_check_d( x2, yy1, yy2, &left2, &right2 );
 return( !( right1 || left2 ) );
}


