/*                                                                
**  Copyright (C) 2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "utlib.h"
void tpio_g_cs( char* prompt, char** pptr, char* token, long siz )
{
 tpio_token(  prompt, pptr, TMODE_STRING, token, siz );
}

void tpio_g_c( char* prompt, char** pptr, char* token, long siz )
{
 tpio_token(  prompt, pptr, TMODE_WORD, token, siz );
}



/* TOKEN PARSER IO using global tpio handles */
/*----------------------------------------------------------------------*/
/*
 * ccop
 * Uses cop.h
 */
void tpio_token( char* prompt, char** pptr, long mode, char* token, long siz )
{
 tpio_tp_token( NULL, NULL, NULL, prompt, pptr, mode, token, siz );
}

void tpio_cs( char* prompt, char* token, long siz )
{
 char** pptr = NULL;
 tpio_tp_token( NULL, NULL, NULL, prompt, pptr, TMODE_STRING, token, siz );
}

void tpio_cc( char* prompt, char* buf, long siz )
{
 tpio_tp_cc( NULL, NULL, NULL, prompt, buf, siz );
}

/*----------------------------------------------------------------------*/
/*
 * icop
 * Uses cop.h readproto.h
 */

long tpio_i( char* prompt )
{
 TextCard token;
 char** pptr = NULL;
 tpio_token( prompt, pptr, TMODE_WORD, token, CARD_SIZE );
 return( cs_read_i( token ) );
}

double tpio_d( char* prompt )
{
 TextCard token;
 char** pptr = NULL;
 tpio_token( prompt, pptr, TMODE_WORD, token, CARD_SIZE );
 return( cs_read_d( token ) );
}

short tpio_s( char* prompt )
{
 TextCard token;
 char** pptr = NULL;
 tpio_token( prompt, pptr, TMODE_WORD, token, CARD_SIZE );
 return( cs_read_s( token ) );
}

float tpio_r( char* prompt )
{
 TextCard token;
 char** pptr = NULL;
 tpio_token( prompt, pptr, TMODE_WORD, token, CARD_SIZE );
 return( cs_read_r( token ) );
}

/*----------------------------------------------------------------------*/
/*
 * ccopw
 * Uses cop.h
 *
 */

void tpio_c( char* prompt, char* token, long siz )
{
 char** pptr = NULL;
 tpio_token( prompt, pptr, TMODE_WORD, token, siz );
}

/*----------------------------------------------------------------------*/
/*
 * ccopl
 * Uses cop.h
 *
 */

void tpio_cl( char* prompt, char* token, long siz )
{
 char** pptr = NULL;
 tpio_token( prompt, pptr, TMODE_LINE, token, siz );
}


long tpio_d_i( char* prompt, long xdefault )
{
 TextCard token;
 char** pptr = NULL;
 tpio_token( prompt, pptr, TMODE_WORD, token, CARD_SIZE );
 if ( cs_is_blank( token ) ) {
  return( xdefault );
 } else {
  return( cs_read_i( token ) );
 }
}

double tpio_d_d( char* prompt, double xdefault )
{
 TextCard token;
 char** pptr = NULL;
 tpio_token( prompt, pptr, TMODE_WORD, token, CARD_SIZE );
 if ( cs_is_blank( token ) ){
  return( xdefault );
 } else {
  return( cs_read_d( token ) );
 }
}

short tpio_d_s( char* prompt, short xdefault )
{
 TextCard token;
 char** pptr = NULL;
 tpio_token( prompt, pptr, TMODE_WORD, token, CARD_SIZE );
 if ( cs_is_blank( token ) ) {
  return( xdefault );
 } else {
  return( cs_read_s( token ) );
 }
}

float tpio_d_r( char* prompt, float xdefault )
{
 TextCard token;
 char** pptr = NULL;
 tpio_token( prompt, pptr, TMODE_WORD, token, CARD_SIZE );
 if ( cs_is_blank( token ) ) {
  return( xdefault );
 } else {
  return( cs_read_r( token ) );
 }
}

