/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "utlib.h"

/*----------------------------------------------------------------------*/
/*
 * jcm_init
 *
 */

void sys_os( char* sysos )
{
 cs_copy( UT_ARCH, sysos );
}


/*----------------------------------------------------------------------*/
/*
 * sys_filepath
 * Uses csproto.h tokenproto.h
 * Unix version only
 */

void sys_filepath( const char* dir, const char* name, const char* ext, char* buf, long siz )
{
 logical current;
 logical absolute;
 
 current = cs_eq( dir, "." ) && !cs_is_blank( name );
 absolute = cs_is_blank( dir ) || name[0] == '/';

 if ( !absolute && !current ) cs_put_token( dir, &buf, '/', &siz );
 if ( !cs_is_blank( name ) ) cs_put_cn( name, &buf, &siz );
 if ( !cs_is_blank( ext ) ) { cs_put_cn( ".", &buf, &siz ); cs_put_cn( ext, &buf, &siz ); }
 if ( siz ) *buf = '\0';
}

/*----------------------------------------------------------------------*/
/*
 * sys_pathstrip
 *
 * Remove leading directories from the path name. Unix only.
 */

void sys_pathstrip( const char* path, char* dir, char* name, const long maxlen )
{
 char* ptr;
 long len;
 ptr = strrchr( path, '/' );
 if ( ptr ) {
  len = min_i( ptr - path, maxlen );
  cs_copy_siz( path, dir, len );
  cs_copy_siz( ptr + 1, name, maxlen );
 } else {
  *dir = 0;
  cs_copy_siz( path, name, maxlen );
 }
}
