/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "utlib.h"

/*======================================================================*/
/*
 * Debug routines
 *
 * Static storage:
 *	debug_val		Debug level, 0 = no debug
 *
 */

logical ut_dbg_level( const long level )
{
 return( level <= ut_dbg_get() );
}

void ut_dbg_msg_tag( const long level, char* buf )
{
 sprintf( buf, "[*%ld]", (long)level );
}

void ut_msg_d( const long level, const char* buf )
{
 TextBuf tbuf;
 TextBuf buf2;
 TextWord tmp;
 if ( level <= ut_dbg_get() ) {
  ut_dbg_msg_tag( level, tmp );
  cs_copy_siz( buf, buf2, TEXT_SIZE-20 ); /* Protect sprintf */
  sprintf( tbuf, "%-6s%s", tmp, buf2 );
  ut_err_msg( tbuf );
 }
}

