/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "utlib.h"
#include "fio.h"
/*
 *------------------------------------------------------*
 */

long fio_tty_in( void )
{
 return fio_list_tty_in(fio_get_list());
}

long fio_tty_out( void )
{
 return fio_list_tty_out( fio_get_list());
}
long fio_tty_err( void )
{
 return fio_list_tty_err( fio_get_list());
}


logical fio_any_eof( long mode )
{
 return fio_list_any_eof( fio_get_list(), mode );
}

void fio_set_retry( logical q )
{
 fio_list_set_retry( fio_get_list(), q );
}

logical fio_get_retry( void )
{
 return fio_list_get_retry( fio_get_list() );
}

FioFile fio_file_ptr( long file )
{
 return fio_list_get_file( fio_get_list(), file );
}

void fio_path_set( char* pathlist )
{
 fio_list_set_path( fio_get_list(), pathlist );
}


void fio_path_list( void )
{
 fio_list_list_path( fio_get_list() );
}


logical fio_inquire_path( char* name, char* pathname, long siz )
{
 logical q;
 q = fio_list_inquire_path( fio_get_list(), name, pathname, siz );
 return q;
}

logical fio_tty_read( char* buf, long siz )
{
 return fio_pager_tty_read( NULL, buf, siz );
}
 
logical fio_tty_writel( char* buf )
{
 return fio_pager_tty_write( NULL, buf, UT_FALSE );
}

logical fio_tty_write( const char* buf )
{
 return fio_pager_tty_write( NULL, buf, UT_TRUE );
}


