/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#ifndef FIOLIST_H
#define FIOLIST_H

#include <termios.h>
#include "utsize.h"
#include "fio.h"

struct FioPager_s {
 long nlines;
 long line;
 logical quiet;
 logical on;
};

#include "iostack.h"

struct FioFileList_s {
 long tty_in;
 long tty_out;
 long tty_err;
 long fio_nfiles;
 long nmax;
 FioFileObject* files;
 logical retry;
 long stdin_is_tty;    /* Is standard input interactive? */
 struct termios termios_arg;
 char termios_cc_save[UT_TERMIOS_TSIZE];
 char termios_cc_raw[UT_TERMIOS_TSIZE];
 long termios_ncc;
 long termios_flags_save[4];
 long termios_flags_raw[4];
 long npath;
 long pathmax;
 char** path;
 FioPager pager;
 FioStack iofs;
};

#endif
