/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "utlib.h"
#include "jcmstate.h"

void fio_list_free_path( FioFileList f )
{
 if ( f->path ) ar_free_cp( f->path, f->npath+1 );
}

void fio_list_set_path( FioFileList f, char* pathlist )
{
 long i;
 Filename tmp;
 TextBuf jcmpath;
 fio_list_free_path( f );

 if ( !pathlist )
 {
  sys_getenv( "JCMPATH", jcmpath );
  pathlist = jcmpath;
 } 
 f->path = cs_parse_paren_list( pathlist, &f->npath );
 for ( i = 1; i <= f->npath; i++ ) {  
  if ( *(f->path[i]) == '$' ) {
   sys_getenv( f->path[i], tmp );
   free( f->path[i] );
   f->path[i] = cs_dup( tmp );

  }
 }

}

void fio_list_list_path( FioFileList f )
{
 long i;
 fio_msg( "JCMPATH directory search path:" );
 for ( i = 1; i <= f->npath; i++ ) {
  fio_msgl( "JCMPATH " );
  fio_msg( f->path[i] );
 }
}



logical fio_list_inquire_path( FioFileList f, char* name, char* pathname, long siz )
{
 logical q;
 long i;
 Filename tmp;
 cs_copy( name, pathname );
 q = fio_inquire( pathname );
 i = 0;
 if ( *name != '/' ) {
  while( !q && i < f->npath ) {
   sys_filepath( f->path[++i], name, " ", tmp, siz );
   q= fio_inquire( tmp );
   if ( q ) cs_copy( tmp, pathname );
  }
 }
 return( q );
}

