/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "utlib.h"
#include "fiolist.h"

FioStack fio_get_stack( void )
{
 FioFileList list = fio_get_list();
 return list->iofs;
}

long fio_stack_get_level( void )
{
 return fio_iostack_get_level( NULL, FIO_INPUT );
}

void fio_stack_opop( long mode )
{
 fio_iostack_opop( NULL, NULL, mode );
}

void fio_stack_ipush( FioFile file )
{
 fio_iostack_ipush( NULL, NULL, NULL, file );
}

void fio_stack_ipop( long mode )
{
 fio_iostack_ipop( NULL, NULL, NULL, mode );
}

void fio_stack_opush( FioFile file )
{
 fio_iostack_opush( NULL, NULL, file );
}

void ut_err_msg( const char* buf )
{
 fio_write_line( fio_iostack_file( NULL, FIO_ERR), buf );
}

FioFile fio_stack_file( long mode )
{
 return fio_iostack_file( NULL, mode );
}

void fio_stack_set_err( FioFile file )
{
 fio_iostack_set( NULL, NULL, file, FIO_ERR );
}

void fio_stack_out( FioFile file )
{
 fio_iostack_set( NULL, NULL, file, FIO_OUTPUT );
}

void fio_stack_in( FioFile file )
{
 fio_iostack_set( NULL, NULL, file, FIO_INPUT );
}


logical fio_stack_interactive( long mode )
{
 return( fio_file_interactive( fio_iostack_file( NULL, mode ) ));
}

void fio_stack_set_detab( logical q )
{
 fio_iostack_set_detab( fio_get_stack(), q );
}

logical fio_stack_read( char* buf, char* prompt, long siz )
{
 return fio_iostack_read( NULL, buf, prompt, siz );
}


void fio_stack_rewind_input( void )
{
 fio_iostack_rewind_input( NULL );
}

FioFile fio_stack_input_entry( long level )
{
 return fio_iostack_input_entry( NULL, level );
}

logical fio_stack_read_input( char* buf, long siz )
{ 
 FioFile file = fio_iostack_file( NULL, FIO_INPUT );
 return( fio_read_line( file, buf, siz ) );
} 


