/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */


#include <stdio.h>

#include "fio.h"
#include "esc_types.h"
#include "utsize.h"
#include "fiolist.h"
#include "tpio.h"



/*
 ================================================================================
 */

/* UtilVersionData: JCMUTILS internal object describing stack of program versions */

struct UtilVersionData_s {
 long nver;
 char** program;
 char** version;
};





struct UtilNull_s {
 unsigned short s_null;
 unsigned short s_inf; 
 unsigned short s_ninf;
 long i_null;
 long i_inf;
 long i_ninf;
 float r_null;
 float r_inf;
 float r_ninf;
 double d_null;
 double d_inf;
 double d_ninf;
 float r_ieee_nan;
 float r_ieee_inf;
 float r_ieee_ninf;
 double d_ieee_nan;
 double d_ieee_inf;
 double d_ieee_ninf;
};



/*
 ================================================================================
 */

struct UtilState_s {
 char* ver;
 UtilVersionData versions;
 long global_dbg;
 ErrorGlobal error_global;
 unsigned int seed;
/* Files */
 FioFileList fio;
 Tpio tpio;
 UtilEscData escapes;
 UtilNulls nulls;
};


#ifdef UT_STATE_DEF
UtilState jcmlib_state = NULL;
#else
extern UtilState jcmlib_state;
#endif






