/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "utlib.h"
#include "fiolist.h"

void fio_msg( char* buf )
{
 fio_iostack_msg( NULL, NULL, buf, UT_TRUE, UT_FALSE );
}

void fio_tmsg( char* buf )
{
 fio_iostack_msg( NULL, NULL, buf, UT_TRUE, UT_TRUE );
}

void fio_tmsgl( char* buf )
{
 fio_iostack_msg( NULL, NULL, buf, UT_FALSE, UT_TRUE );
}

void fio_msgl( char* buf )
{
 fio_iostack_msg( NULL, NULL, buf, UT_FALSE, UT_FALSE );
}

void fio_set_msg( void (*mf)(char*, logical) ) 
{
 fio_iostack_set_msg( NULL, mf );
}

void fio_iostack_msg( FioStack iofs, FioFileList list, char* buf, logical newline, logical tty )
{
 if ( tty )
  fio_pager_tty_write( list, buf, newline );
 else
 {
  if ( !iofs ) iofs = fio_get_stack();
  iofs->msgfunc( buf, newline );
 }
}


void fio_iostack_set_msg( FioStack iofs, void (*mf)(char*, logical) ) 
{
 if ( !iofs ) iofs = fio_get_stack();
 if ( mf ) {
  iofs->msgfunc = mf;
 } else {
  iofs->msgfunc = fio_std_msg;
 }
}
