/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "dmnutils.h"

/*
 *  Given the pixel coordinates, where in the array are we?
 */
long pixelno_from_pixel( long* Pixel, long* axes, long naxes )
{
 long i;
 long PixelNo = 1;
 long weight = 1;
 for ( i = 0; i < naxes; i++ )
 {
  PixelNo = PixelNo + ( Pixel[i] - 1 ) * weight;
  weight *= axes[i];
 }
 return PixelNo;
}



/*
 *  What are the coordinates of the n'th pixel in the image?
 */
void pixel_from_pixelno( long PixelNo, long* axes, long naxes, long* Pixel )
{
 long weight = 1;
 long i;
 long Count = PixelNo-1;
/* Calculate weight of largest axis */
 for ( i = 0; i < naxes-1; i++ ) 
 {
  weight *= axes[i];
  Pixel[i] = 0;
 }

 for ( i = naxes-1; i >= 0; i-- )
 {
  Pixel[i] = Count / weight + 1;
  Count = Count % weight;

  if ( i > 0 ) weight = weight / axes[i-1];

  if ( weight <= 0 ) return;
 }
}


