/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include <time.h>
#include "utlib.h"


/* Return rno dist uniform on [0,1] */
double ut_rand( void )
{
 unsigned int* seed = ut_state_seed(NULL); 
 return ut_rand_eval( seed );
}

/* From stdlib.h */

double ut_rand_eval( unsigned int* seed )
{
 double r;

#if defined (__CYGWIN32__)
 /* cygwin doesn't have a rand_r */
 if ( *seed )
  srand( *seed );
 r = (double)rand();
#else
 if ( *seed == 0 ) *seed = time( NULL );
 r = (double)rand_r( seed ); 
#endif

 return r / RAND_MAX;
}
