/*                                                                
**  Copyright (C) 2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

#include "utlib.h"


void cs_sex_fmt( const logical sg, const long d, const long m, const long s, const double fs, char* buf, const long siz )
{
 TextWord buf1;
 TextWord buf2;
 char* ptr;

 buf2[0] = sg ? '+' : '-';
 sprintf( buf1, "%11.9f", fs );
 if ( buf1[0] == '1' ) cs_copy( "0.999999999", buf1 );
 ptr = buf2 + 1;
 if ( d > 99 ) {
  ptr += sprintf( ptr, "%03ld", (long)d );
 } else {
  ptr += sprintf( ptr, "%02ld", (long)d );
 }
 sprintf( ptr, ":%02ld:%02ld%s", (long)m, (long)s, buf1+1 );
 cs_copy_siz( buf2, buf, siz );
}




char* cs_sexwrite_d( const double x, char* buf, const long siz )
{
 logical sg;
 long d,m,s;
 double fs;
 sx_wval_to_sxa_d( x, UT_CIRCLE, &sg, &d, &m, &s, &fs );
 cs_sex_fmt( sg, d, m, s, fs, buf, siz );
 return( buf );
}

char* cs_sexwrite_hr_d( const double x, char* buf, const long siz )
{

 logical sg;
 long d,m,s;
 double fs;
 double x1;
 TextWord buf1;
 x1 = circ_d( x );
 sx_wval_to_sxa_d( x1, 24, &sg, &d, &m, &s, &fs );
 cs_sex_fmt( sg, d, m, s, fs, buf1, WORD_SIZE );
 cs_copy_siz( buf1+1, buf, siz );
 return( buf );
}

