/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

/* Internal unit routines */
#ifndef UNIT_REG_H
#define UNIT_REG_H

typedef struct {
 long n;
 long nmax;
 char** base;
 double* exp;
 long* fac;
} UnitRegister;

struct  UnitDomain_s {
 char** unit;
 char** def;
 long n;
 logical texmode;
 UnitRegister* ureg1;
 UnitRegister* ureg2;
};

void unit_free( UnitRegister* unit );
UnitRegister* unit_alloc( long n );
void unit_regmult( UnitRegister* reg1, UnitRegister* reg2, long power2 );
void unit_regdedup( UnitRegister* reg, UnitRegister* temp );
void unit_regcompose( UnitRegister* reg, logical texmode, char* unit, long siz );
void unit_regresolve( UnitDomain u );
void unit_ddisp( UnitRegister* reg );
void unit_regexp( UnitRegister* reg, double power );
void cs_unit_si_resolve( char** unit, long n, char** d_unit, long dn, long* fac );
void cs_unit_regparse( UnitDomain u, const char* unit, UnitRegister* reg );
void cs_unit_parse( const char* unit, UnitRegister* reg );
void cs_unit_reg_enlarge( UnitRegister* reg, long n );
#endif
