/*                                                                
**  Copyright (C) 2002-2003,2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */





typedef struct {
 long zero;        /* Dummy */
 struct ut_double_circ {
  double polar_lat;
  double twopi;
  double circle;
  double deg_rad;
 } d;
 struct ut_float_circ {
  float   polar_lat;
  float   twopi;
  float   circle;
  float   deg_rad;
 } r;
} UtilConstants;

/* UT_BIGEND is defined in ../../inc/config.h */
#if UT_BIGEND
#define BYTE_SWAPPED 0
#define UT_R8_WORD1 2
#define UT_R8_WORD2 1
#else
#define BYTE_SWAPPED 1
#define UT_R8_WORD1 1
#define UT_R8_WORD2 2
#endif


#define UT_VERBOSE       1
#define UT_VERBOSE_UNIT  5
#define UT_VERBOSE_FIO   10
#define UT_VERBOSE_PARSE 12

/* To convert from signed to unsigned */
#define UT_BIG_INT 65536
#define UT_BYTE_BITS 8

#define UT_NGREEK 24
#define UT_PARSE_NTYPES 28
#define UT_NCHARS 128

#define UT_UNIT_MANT_POS 0
#define UT_SI_NPFX 8
#define UT_SI_MICRO "\\mu"


#define UT_APPROX_ARG_1  1.0E-6
#define UT_FUNC_TOL      1.0E-5
#define UT_MAX_EXP_ARG 700.0
#define UT_MIN_EXP_ARG 1.0E-10
#define UT_MIN_SINH_ARG 1.0E-10
#define UT_MAX_SINH_ARG 1.0E+40
#define UT_TINY_D 1.0E-100

#define UT_PREFER_HEAPSORT 1000

/*  An IDX is a C array index counting from 0 */
/*  An ID  is a Fortran style index from 1 */

typedef long ArrayOffset;
typedef long ArrayIndex;

/* The error codes are 1024 * class_no + class_entry */
#define UT_ERR_CLASS 1024
#define UT_ERR_CLASS_INIT_SIZE 20



typedef struct {
 char echar;
 char edefault;
 char name[8];
} UtilEscapes;

struct UtilEscapeData_s {
 UtilEscapes* data;
 long n;
};

typedef struct UtilEscapeData_s *UtilEscData;
typedef struct UtilState_s *UtilState;
typedef struct UtilVersionData_s *UtilVersionData;
typedef struct UtilNull_s *UtilNulls;
