/*                                                                
**  Copyright (C) 1999-2001,2003-2004,2006-2007  Smithsonian Astrophysical Observatory 
*/                                                                

/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 3 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful,         */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           */
/*  GNU General Public License for more details.                            */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.             */
/*                                                                          */

/* ***************************************************************************** */
/*  FILE NAME: 		@(#)dmlistlib.h	1.1 98/04/03 13:15:03                    */
/*                                                                               */
/*  DEVELOPMENT: 	AXAF Science Center DataModel Tools                      */
/*                                                                               */
/*  DESCRIPTION:	Header file for dmlist DM tool.                          */
/*                                                                               */
/* ***************************************************************************** */

#ifndef DM_DATA_LIST
#define DM_DATA_LIST

/* trigger loading of dmnutils.h */
#ifndef DMLIB_INTERNAL
#define DMLIB_INTERNAL
#endif

#include "ascdm.h"

#ifdef _cplusplus
extern "C" {
#endif

#ifndef FALSE
#define FALSE 0
#define TRUE  1
#endif

#define DML_MAX_ARR 100

#define DMA_MODE_FORCE_IMAGE  0x01
#define DMA_MODE_COPY_ALL     0x02
#define DMA_MODE_CLOBBER      0x04
#define DMA_MODE_TEXT         0x08
#define DMA_DELETE_GTI        0x10
#define DMA_MODE_COPY_BARE    0x20

#define DMA_MODE_MERGE  0
#define DMA_MODE_COPY   1
#define DMA_MODE_LIST   2

#define DMT_FORCE_ARRAY_PARS 2

typedef struct
{
  dmDataset*  ds;
  dmBlock*    block;           /* Block pointer */
  char*       name;            /* Block name    */
  char*       toolname;        /* Name of tool.. for HISTORY */
  int*        is_dss_block;    /* is_dss_block[i] is true if block i is a 
				* subspace block attached to the main block */
  int         copy_subspace;
  int         main;
  long        nfiles;
  int         first;
  char*       input;
} dmCopyInfo;

typedef struct
{
  int PrintRaw;
  int PrintCounts;
  int PrintBins;
  int PrintFull;
  int PrintArray;
  int PrintAll;
  int PrintBlocks;
  int PrintHeader;
  int PrintCols;
  int PrintSubspace;
  int PrintData;
  int PrintAny;
  int PrintClean;
  int PrintComment;
  long minrow;
  long maxrow;
  long mincell;
  long maxcell;

  int mode;

} dmListInfo;

typedef dmBlock* (*BlockProcess)(dmBlock*, int, void*, void*);


#ifdef _cplusplus
}
#endif

#endif


