// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef AHELPDIRECTORY_HH
#define AHELPDIRECTORY_HH


#include "AhelpStrings.hh"

class AhelpDirectory : public AhelpStringsList
{
public:

  enum DirMode {NO_MODE,DIR_MODE,R_MODE,W_MODE,X_MODE,EXIST_MODE};
  // Constructor
  AhelpDirectory();
  AhelpDirectory(char *filename,DirMode mode=NO_MODE,Boolean dotfiles=FALSE);
  AhelpDirectory(char *filename,char *regexp,DirMode mode=NO_MODE,
  						Boolean dotfiles=FALSE);

  // Destructor
  ~AhelpDirectory();


  // Read in filenames from a specified directory path
  Boolean ReadDir(char *,DirMode mode=NO_MODE,Boolean dotfiles=FALSE);

protected:
  // Objects

private:
  char *_regexp;		// regular expression for filtering

};


#endif
