// 
//  Copyright (C) 2002,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef __AHELPUTILS_HH__
#define __AHELPUTILS_HH__


#include "AhelpStrings.hh"


AhelpStrings GetRegularExpression(const AhelpStrings& inString);

void AhelpPostWarning(const char *warn_txt, const char *kind = "Warning: ");


#ifdef __cplusplus
extern "C" {
#endif

extern Boolean Ahelp_find_file_delim(const char *env, const char *name,
                               const int mode, char *ret_path,
                               const char *delim);
extern Boolean Ahelp_find_file(const char *env, const char *name, const int mode,
                         char *ret_path);


#ifdef __cplusplus
}
#endif


AhelpStrings AhelpGetUserName();



const char *GetAhelpResource(const char *resource);

const char *GetAhelpWorkPath();

Boolean AhelpCheckForProcess(AhelpStrings name, Boolean checkuser=TRUE);

AhelpStrings AhelpGetHomeDir(void); 


#endif
