// 
//  Copyright (C) 2002,2003,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//



#ifndef __DTDELEMENT_HH__
#define __DTDELEMENT_HH__


#include "AhelpStrings.hh"
#include "AhelpList.hh"



class  DTDElement
{

public:
  DTDElement();
  DTDElement(const DTDElement& inELement);
  virtual ~DTDElement();
  virtual void Format(AhelpStrings& outFormattedString);
  virtual void Reset();
  virtual int CanCompact(AhelpStrings& inBlockName ) { return 1;};
  bool IsEmpty();
  friend ostream& operator <<(ostream& outstream,DTDElement& inElement) { outstream << inElement.name; return outstream;}; 


  AhelpStrings name;
  AhelpList<AhelpStrings> attributes;
  AhelpStrings data;
  DTDElement* parent;
  AhelpList<DTDElement> children;

  
  static const AhelpStrings TOK_PCDATA;

};

#endif
