// 
//  Copyright (C) 2002,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef __LOOKUPTABLE_HH__
#define __LOOKUPTABLE_HH__

#include "AhelpStrings.hh"


class Bucket
{
public:
  Bucket(){value=0;next=0;};
  virtual ~Bucket(){if ( next != 0) delete next;};
  int value;
  AhelpStrings index;
  Bucket* next;

};


class LookupTable
{
public:
  LookupTable(unsigned long long  inSize);
  virtual ~LookupTable();
  int& operator[](const AhelpStrings& inStringsIndex);


private:
  unsigned long long Hash( register char *k, register unsigned long long length, register unsigned long long  level);
  Bucket** table;
  unsigned long long size;

};

#endif
