// 
//  Copyright (C) 2002,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef __TEXTBLOCKTABLE_HH__
#define __TEXTBLOCKTABLE_HH__

#include "AhelpList.hh"
#include "AhelpStrings.hh"
#include "TextBlock.hh"

class TableData
{
  friend class TextBlockTable; 
public:
  TableData(int inColCount);
  void SetHeader(AhelpList<AhelpStrings>& inHeader);
  void AddRow(AhelpList<AhelpStrings>& inRow);

protected:
  void SetColumnWidths(AhelpList<AhelpStrings>& inRow,AhelpList<int>& outWidths);

private:
  int colCount;
  AhelpList< AhelpList<AhelpStrings> > rows;
  AhelpList<AhelpStrings> header;
  AhelpList<int> colWidths;
  AhelpList<int> headerColWidths;

};

class TextBlockTable: public TextBlock
{
public:
  TextBlockTable(TableData& inTableData,int inMaxWidth,int inCompactFlag=1,int inSqueezeColNo=-1);

  


};

#endif
