// 
//  Copyright (C) 2002,2003,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include <termios.h>
#include "AhelpInterface.hh"
#include "AhelpPager.hh"



int main(int argc, char **argv)
{


  AhelpStringsList optionsList;
  AhelpStrings outInfo;
  int  status=1;

  for(int indx =1;indx< argc;indx++)
    {
      optionsList.Append(argv[indx]);
    };
      

  
  status = GlobalAhelpInterface::GetHelp(optionsList,outInfo);

  if (! outInfo.isEmpty())
    {
      if ( status > 0 )
	{
	  if ( isatty(STDOUT_FILENO) )
	    {
	      AhelpPager pager;
	      
	      pager << outInfo.chars();
	    }
	  else
	    {
	      cout<<outInfo.chars()<<endl;
	    };
	}
      else
	{
	  cerr << outInfo.chars()<<endl;
	};
    };

  if ( status > 0 )
    status = 0;
  else if ( status < 0 )
    status = 2;
  else
    status = 1;

  return status;
}
