#!/bin/ksh


#
# Conversion utility tex files that include other tex files
# (generated from xml files) to html 
#
#
#

APPLICATION_PATH=/proj/ascr4/rmilas/bin/

export JAVA_HOME=/soft/jdk1.2.2

export CLASSPATH=".:/proj/ascr4/rmilas/xml-tr1/xml.jar:/proj/ascr4/rmilas/xsl/xslp.jar:/proj/ascr4/rmilas/xsl/xml4j_1_1_14.jar:${APPLICATION_PATH}"


if [ -z "${ASCDS_INSTALL}" ]
then
    echo "Error: ASCDS_INSTALL is not set"
    exit 1
fi


if [ $# -lt 1 ] 
then
    echo "Usage: texxml2html.ksh texfile1 texfile2 ...."
    exit 1
fi


for FILE in $*
do


    # find included tex files in main tex document and try to generate them
    # from xml files

    
    for XMLFILE in `grep "\include" $FILE | grep -v "%"| sed "s/^.*{//"|sed "s/}.*$//"`
    do
	echo " ${XMLFILE}.xml"
	if [ -a ${XMLFILE}.xml ]
	then
	    ${JAVA_HOME}/bin/java xml2tex -i ${ASCDS_INSTALL} -oneOutFile  ${XMLFILE}.xml
	    sed 's/longtable/tabular/' ${XMLFILE}.tex | sed 's/\\endhead//' | sed '/^\\label{sec/s/\\_/_/g' > ${XMLFILE}.tex.$$
	    mv ${XMLFILE}.tex.$$ ${XMLFILE}.tex
	fi
    done
	
    ${APPLICATION_PATH}/lt2html $FILE "$FILE" 

done

